/******************************************************************************************************************************************
 *
 * Filename    : mem2test.h
 * Project     : MemAlloc
 * Description : This is an example implementation of the C memory functions malloc(), free(), calloc() and realloc().
 *               It should serve as an tutorial for learning - it's not an efficient, optimized implementation.
 *
 *               See the corresponding article on my homepage for explanation of the algorithms.
 *
 *               Header file for the test cases for implementation variant 2 C memory functions.
 *
 * Sunshine, October 2k19
 * www.sunshine2k.de | www.bastian-molkenthin.de
 *
 * This file is licensed under MIT licence. For further details, see http://www.sunshine2k.de/license.html.
 *
 *****************************************************************************************************************************************/
#pragma once

/******************************************************************************************************************************************
 * INCLUDES
 *****************************************************************************************************************************************/
#include <stdint.h>
#include "mem2.h"

/******************************************************************************************************************************************
 * DEFINES
 *****************************************************************************************************************************************/

/******************************************************************************************************************************************
 * FUNCTION DECLARATIONS
 *****************************************************************************************************************************************/

#if defined ( MEM2_TEST_MODE )
/****************
 * Test cases
 ****************/
void mem2test_FullHeapAlloc(void);
void mem2test_FullHeapAllocInSecondRequest(void);
void mem2test_FullHeapAllocInSecondRequest_FreeReversedOrder(void);
void mem2test_AllocRequestSizeTooLarge(void);
void mem2test_FreeBasic(void);
void mem2test_FreeLatestToFirst(void);
void mem2test_FreeFirstToLatest(void);
void mem2test_FreeMiddlePrevious(void);
void mem2test_FreeMiddleNext(void);
void mem2test_FreeMiddleTwoPrevious(void);
void mem2test_FreeMiddleTwoNext(void);
void mem2test_ReallocLargerSize(void);
void mem2test_ReallocSmallerSize(void);
#endif