/******************************************************************************************************************************************
 *
 * Filename    : testutil.h
 * Project     : MemAlloc
 * Description : This is an example implementation of the C memory functions malloc(), free(), calloc() and realloc().
 *               It should serve as an tutorial for learning - it's not an efficient, optimized implementation.
 *
 *               See the corresponding article on my homepage for explanation of the algorithms.
 *
 *               Header file for test utility functions.
 *
 * Sunshine, October 2k19
 * www.sunshine2k.de | www.bastian-molkenthin.de
 *
 * This file is licensed under MIT licence. For further details, see http://www.sunshine2k.de/license.html.
 *
 *****************************************************************************************************************************************/
#pragma once

/******************************************************************************************************************************************
 * INCLUDES
 *****************************************************************************************************************************************/
#include <stdint.h>

/******************************************************************************************************************************************
 * DEFINES
 *****************************************************************************************************************************************/

/******************************************************************************************************************************************
 * FUNCTION DECLARATIONS
 *****************************************************************************************************************************************/
void    test_init(void);

void    test_assert_not_null_ptr(void* p);
void    test_assert_null_ptr(void* p);
void    test_assert_equal(uint32_t isValue, uint32_t expValue);

void    test_testcase_start(char* testcasetitle);
void    test_testcase_end(void);

uint8_t test_get_testcase_failed(void);
uint8_t test_get_test_failed(void);

